﻿using Hotline.Share.Dtos.File;
using Hotline.Share.Enums.Order;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.Order
{
	public class OrderScreenDto
	{
		/// <summary>
		/// 工单编号
		/// </summary>
		public string No { get; set; }

		/// <summary>
		/// 回访id
		/// </summary>
		public string VisitId { get; set; }

		/// <summary>
		/// 回访明细id
		/// </summary>
		public string VisitDetailId { get; set; }

		/// <summary>
		/// 工单id
		/// </summary>
		public string OrderId { get; set; }

		/// <summary>
		/// 甄别申请类型id
		/// </summary>
		public string TypeDicId { get; set; }

		/// <summary>
		/// 甄别申请类型名称
		/// </summary>
		public string TypeDicName { get; set; }


		/// <summary>
		/// 甄别申请原因
		/// </summary>
		public string Content { get; set; }

		/// <summary>
		/// 甄别申请回复
		/// </summary>
		public string? ReplyContent { get; set; }

		/// <summary>
		/// 甄别申请状态
		/// </summary>
		public EScreenStatus? Status { get; set; }

		/// <summary>
		/// 甄别截至申请时间
		/// </summary>
		public DateTime? ApplyEndTime { get; set; }

		/// <summary>
		/// 附件列表
		/// </summary>
		public List<FileDto> Files { get; set; } = new();
	}

	public class OrderScreenListDto
	{
		/// <summary>
		/// 工单编号
		/// </summary>
		public string No { get; set; }

		/// <summary>
		/// 工单id
		/// </summary>
		public string VisitId { get; set; }

		/// <summary>
		/// 工单id
		/// </summary>
		public string OrderId { get; set; }

		/// <summary>
		/// 回访
		/// </summary>
		public OrderVisitDto Visit { get; set; }

		/// <summary>
		/// 工单
		/// </summary>
		public OrderDto Order { get; set; }

		/// <summary>
		/// 回访明细id
		/// </summary>
		public string VisitDetailId { get; set; }

		/// <summary>
		/// 回访
		/// </summary>
		public OrderVisitDetailDto VisitDetail { get; set; }

		/// <summary>
		/// 甄别申请类型id
		/// </summary>
		public string? TypeDicId { get; set; }

		/// <summary>
		/// 甄别申请类型名称
		/// </summary>
		public string? TypeDicName { get; set; }


		/// <summary>
		/// 甄别申请原因
		/// </summary>
		public string? Content { get; set; }

		/// <summary>
		/// 甄别申请回复
		/// </summary>
		public string? ReplyContent { get; set; }


		/// <summary>
		/// 甄别截至申请时间
		/// </summary>
		public DateTime? ApplyEndTime { get; set; }

		/// <summary>
		/// 甄别申请状态
		/// </summary>
		public EScreenStatus? Status { get; set; }

		public string StatusText => Status.GetDescription();

		public DateTime? LastModificationTime { get; set; }

		public bool IsDeleted { get; set; }

		/// <summary>
		/// 删除时间
		/// </summary>
		public DateTime? DeletionTime { get; set; }


		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreationTime { get; set; }

		public string Id { get; set; }

		/// <summary>
		/// 组织Id
		/// </summary>
		public string? CreatorOrgId { get; set; }


		public string? CreatorOrgName { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public string? CreatorId { get; set; }

		public string? CreatorName { get; set; }
	}

	public class PublishScreenDto {
		// <summary>
		/// 工单对象
		/// </summary>
		public OrderDto Order { get; set; }

		/// <summary>
		/// 甄别
		/// </summary>
		public OrderScreenListDto Screen { get; set; }

		/// <summary>
		/// 附件
		/// </summary>
		public string ClientGuid { get; set; }
	}

	public class PublishSuperviseDto {
		// <summary>
		/// 工单对象
		/// </summary>
		public OrderDto Order { get; set; }


		public SuperviseOrderDto Supervise { get; set; }

		/// <summary>
		/// 附件
		/// </summary>
		public string ClientGuid { get; set; }
	}
	public class PublishUrgeDto
	{
		// <summary>
		/// 工单对象
		/// </summary>
		public OrderDto Order { get; set; }

		public UrgeOrderDto Urge { get; set; }

		/// <summary>
		/// 附件
		/// </summary>
		public string ClientGuid { get; set; }
	}
}
